"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createProdMockServer = void 0;
/*
 * @Description: For use in a production environment. Note that this time the file upload will fail
 */
const mockjs_1 = __importDefault(require("mockjs"));
const param2Obj_1 = require("./param2Obj");
function createProdMockServer(mockList) {
    for (const { url, method, response, timeout } of mockList) {
        setupMock(timeout);
        mockjs_1.default.mock(new RegExp(url), method || 'get', XHR2ExpressReqWrap(response, timeout));
    }
}
exports.createProdMockServer = createProdMockServer;
function XHR2ExpressReqWrap(handle, timeout = 0) {
    return function (options) {
        let result = null;
        if (handle instanceof Function) {
            const { body, type, url } = options;
            result = handle({
                method: type,
                body: JSON.parse(body),
                query: param2Obj_1.param2Obj(url),
            });
        }
        else {
            result = handle;
        }
        return mockjs_1.default.mock(result);
    };
}
function setupMock(timeout = 0) {
    if (timeout) {
        mockjs_1.default.setup({
            timeout,
        });
    }
}
